#include<userlib.h>
#include "OthelloBoard.h"

/*----------------------------------------------------------------------
    Monaץꥱ
----------------------------------------------------------------------*/
class myApplication : public MonaApplication, public Observer {

  public:
    myApplication(char* name);
    virtual ~myApplication() {}

  public:
    virtual int main(List<char*>* pekoe);
    virtual void onKeyDown(int keycode, int modifiers);
    virtual void onMouseClick(int x, int y);
    virtual void update(Observable* o, void* arg);

  public:
    virtual void init();
    virtual void drawBoard();
    virtual void drawPieces(int x, int y);

  public:
    static const int PIECE_SIZE = 40;

  protected:
    OthelloBoard* board;
    Screen* virtualScreen;
    Screen screen;

};

/*----------------------------------------------------------------------
    Mainؿ
----------------------------------------------------------------------*/
int MonaMain(List<char*>* pekoe) {

    monaApp = new myApplication("OTHELLO");
    monaApp->main(pekoe);
    monaApp->onMouseClick(5, 5);
    return 0;
}

/*----------------------------------------------------------------------
    myApplication
----------------------------------------------------------------------*/

// 󥹥ȥ饯
myApplication::myApplication(char* name) : MonaApplication(name) {
}

// main
int myApplication::main(List<char*>* pekoe) {

    // 
    init();

    // Ĥν֤
    drawBoard();

    // ٥ȤԤ
    for (;;);
    return 0;
}

// Ĥ
void myApplication::drawBoard() {

    for (int x = 0; x < OthelloBoard::BOARDW; x++) {
        for (int y = 0; y < OthelloBoard::BOARDH; y++) {
            drawPieces(x, y);
        }
    }
}

// (x, y)ˤҤȤ
void myApplication::drawPieces(int x, int y) {

    int piece = this->board->getPiece(x, y);
    int s = PIECE_SIZE;

    // ΢ХåեVRAMž
    switch(piece) {

    case(OthelloBoard::BLACK):
        Screen::bitblt(&screen, x * s, y * s, s, s, virtualScreen, 0, 0);
        break;
    case(OthelloBoard::WHITE):
        Screen::bitblt(&screen, x * s, y * s, s, s, virtualScreen, s, 0);
        break;
    case(OthelloBoard::EMPTY):
        Screen::bitblt(&screen, x * s, y * s, s, s, virtualScreen, 2 * s, 0);
        break;
    default:
        break;
    }
}

// ϤϤʤ
void myApplication::onKeyDown(int keycode, int modifiers) {
}

// ޥå٥
void myApplication::onMouseClick(int x, int y) {

    // ĤΤɤå줿
    int bx = (x - x % PIECE_SIZE) / PIECE_SIZE;
    int by = (y - y % PIECE_SIZE) / PIECE_SIZE;

    // ϰϥå
    if (!board->checkRange(bx, by)) {
        return;
    }

    // ߤΥץ쥤䡼ޤ򤪤
    int current = board->getCurrentHand();
    if (!(board->setPiece(bx, by, current))) {
        return;
    }

    // Ҥä֤뤳ޤ示
    while (board->existNotReversedPieces()) {

        board->reverseNext();
    }
}

// ĤƤѹäȤδؿΤ
void myApplication::update(Observable* o, void* arg) {

    if (arg == NULL) {
        drawBoard();
    } else {

        Point* point = (Point*)arg;
        drawPieces(point->x, point->y);
    }
}

void myApplication::init() {

    // ޥСȼʬȤPID
    dword myPid   = System::getPID();
    dword destPid = Message::lookup("MOUSE.SVR");

    // ޥФϵưƤ롩
    if (destPid == 0) {
        printf("process MOUSE.SVR not found\n");
        exit(-1);
    }

    // ޥС˥ޥ򤯤褦˼ʬȤϿå 
    MessageInfo info;
    Message::create(&info, MSG_MOUSE_REGIST_TO_SERVER, myPid, 0, 0, NULL);
    if (Message::send(destPid, &info)) {
        printf("regist error\n");
    }

    // Ĥ
    this->board = new OthelloBoard();

    // ĤѹäΤƤ餦
    this->board->addObserver(this);

    // ΢ХåեѤ˲ۥ꡼
    virtualScreen = new VirtualScreen(200 * 1024);

    // ʤȤݡݡʤ΢Хåե
    int s = PIECE_SIZE;
    int s1 = (int)(0.5 * s);
    virtualScreen->fillRect16(0, 0, s, s, Color::rgb(0x00, 0xFF, 0x00));
    virtualScreen->fillRect16(s , 0, s, s, Color::rgb(0x00, 0xFF, 0x00));
    virtualScreen->fillCircle16(s1 * 3, s1, s1 - 4, Color::rgb(0xFF, 0xFF, 0xFF));
    virtualScreen->fillCircle16(s1, s1, s1 - 4, Color::rgb(0x00, 0x00, 0x00));
    virtualScreen->fillRect16(s * 2, 0, s, s, Color::rgb(0x00, 0xFF, 0x00));

    for (int x = 0; x < 3 * s; x++) {
        virtualScreen->putPixel16(x, s - 1, Color::rgb(0x00, 0x00, 0x00));
    }

    for (int x = 0; x < 3 * s; x++) {
        virtualScreen->putPixel16(x, 0, Color::rgb(0x00, 0x00, 0x00));
    }

    for (int x = 0; x <= 3 * s; x += s) {
        for (int y = 0; y < 3 * s; y++) {
            virtualScreen->putPixel16(x - 1, y, Color::rgb(0x00, 0x00, 0x00));
        }
    }
}

